#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 2 "yaccLTL.cc"

/*
This software has been determined to be outside the scope of NASA NPG 2210 and
therefore is not considered as controlled software.

This program may be freely redistributed and/or modified under the terms of
this software agreement.

NASA is neither liable nor responsible for maintenance, updating, or
correction of any errors in the software provided.

Use of this software shall not be construed to constitute the grant of a
license to the user under any NASA patent, patent application or other
intellectual property.

THE SOFTWARE IS PROVIDED 'AS IS' WITHOUT ANY WARRANTY OF ANY KIND, EITHER
EXPRESSED, IMPLIED, OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, ANY WARRANTY
THAT THE SOFTWARE WILL CONFORM TO SPECIFICATIONS, ANY IMPLIED WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND FREEDOM FROM
INFRINGEMENT, AND ANY WARRANTY THAT THE DOCUMENTATION WILL CONFORM TO THE
SOFTWARE, OR ANY WARRANTY THAT THE SOFTWARE WILL BE ERROR FREE.  IN NO EVENT
SHALL NASA BE LIABLE FOR ANY DAMAGES, INCLUDING, BUT NOT LIMITED TO, DIRECT,
INDIRECT, SPECIAL OR CONSEQUENTIAL DAMAGES, ARISING OUT OF, RESULTING FROM, OR
IN ANY WAY CONNECTED WITH THIS SOFTWARE, WHETHER OR NOT BASED UPON WARRANTY,
CONTRACT, TORT , OR OTHERWISE, WHETHER OR NOT INJURY WAS SUSTAINED BY PERSONS
OR PROPERTY OR OTHERWISE, AND WHETHER OR NOT LOSS WAS SUSTAINED FROM, OR AROSE
OUT OF THE RESULTS OF, OR USE OF, THE SOFTWARE OR SERVICES PROVIDED
HEREUNDER.
 
RECIPIENT AGREES TO WAIVE ANY AND ALL CLAIMS AGAINST THE U.S. GOVERNMENT, THE
U.S. GOVERNMENT'S CONTRACTORS AND SUBCONTRACTORS, AND SHALL INDEMNIFY AND HOLD
HARMLESS THE U.S. GOVERNMENT AND THE U.S. GOVERNMENT'S CONTRACTORS AND
SUBCONTRACTORS FOR ANY DAMAGE THAT MAY BE INCURRED FROM RECIPIENT'S PRIOR OR
FUTURE USE OF THE PROVIDED SOFTWARE, INCLUDING ANY DAMAGES FROM PRODUCTS BASED
ON, OR RESULTING FROM, THE USE THEREOF.  RECIPIENT AGREES TO OBTAIN THIS
IDENTICAL WAIVER OF CLAIMS, INDEMNIFICATION AND HOLD HARMLESS AGREEMENT WITH
ANY ENTITIES THAT ARE PROVIDED WITH TECHNICAL DATA DERIVED FROM USE OF THE
SOFTWARE.

K.Y.Rozier
June, 2011
*/

/* This is a parser for LTL formulas in in-fix order */

#include "PANDA.h"


int yylex(); /*to make g++ shut up*/

int yyerror(const char *msg) { /*to make g++ shut up*/
    (void) fprintf(stderr, "%s\n", msg);
    return (0);
} /*end yyerror*/

/*Variable declarations*/   
 struct node *current;
 int i;

 KItem search;            /*a variable name to search for*/
 int used;                /*did we use this var already?*/


/*for parsing the formula string*/
#undef YY_INPUT
#define YY_INPUT(b, r, ms) (r = my_yyinput(b, me))

#line 71 "yaccLTL.cc"
typedef union {
    struct node *nPtr;		/* node pointer */
    char *varName;              /* name of a variable */
} YYSTYPE;
#line 90 "y.tab.c"
#define YYERRCODE 256
#define AND 257
#define OR 258
#define NOT 259
#define IMPLIES 260
#define NEXT 261
#define UNTIL 262
#define GLOBALLY 263
#define LPAREN 264
#define RPAREN 265
#define PROP 266
#define FFALSE 267
#define TTRUE 268
#define RELEASE 269
#define FUTURE 270
const short yylhs[] = {                                        -1,
    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,
};
const short yylen[] = {                                         2,
    1,    1,    1,    1,    2,    2,    2,    2,    3,    3,
    3,    3,    3,    3,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    0,    2,    4,    3,    0,    0,    0,
    5,    6,    7,    0,    8,    0,    0,    0,    0,    0,
   14,    9,    0,    0,    0,    0,
};
const short yydgoto[] = {                                       9,
   10,
};
const short yysindex[] = {                                   -218,
 -218, -218, -218, -218,    0,    0,    0, -218,    0, -225,
    0,    0,    0, -231,    0, -218, -218, -218, -218, -218,
    0,    0, -257, -204, -240, -246,
};
const short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   10,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    1,    2,    3,    4,
};
const short yygindex[] = {                                      0,
    5,
};
#define YYTABLESIZE 273
const short yytable[] = {                                      16,
   10,   11,   12,   13,    0,   11,   12,   13,   14,    1,
   16,   17,   15,   18,    0,   19,   16,   17,    0,   18,
   22,   23,   24,   25,   26,   16,   17,    0,   18,    0,
   19,   16,   17,   21,   18,    0,   19,   20,    0,    0,
    1,    0,    2,   20,    3,    4,    0,    5,    6,    7,
    0,    8,   16,   17,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   10,    0,
   10,   11,   10,   11,   12,   10,   11,   12,   13,   10,
   11,   12,   13,
};
const short yycheck[] = {                                     257,
    0,    0,    0,    0,   -1,    1,    2,    3,    4,    0,
  257,  258,    8,  260,   -1,  262,  257,  258,   -1,  260,
   16,   17,   18,   19,   20,  257,  258,   -1,  260,   -1,
  262,  257,  258,  265,  260,   -1,  262,  269,   -1,   -1,
  259,   -1,  261,  269,  263,  264,   -1,  266,  267,  268,
   -1,  270,  257,  258,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  258,   -1,
  260,  260,  262,  262,  262,  265,  265,  265,  265,  269,
  269,  269,  269,
};
#define YYFINAL 9
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 270
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"AND","OR","NOT","IMPLIES","NEXT",
"UNTIL","GLOBALLY","LPAREN","RPAREN","PROP","FFALSE","TTRUE","RELEASE","FUTURE",
};
const char * const yyrule[] = {
"$accept : input",
"input : formula",
"formula : PROP",
"formula : TTRUE",
"formula : FFALSE",
"formula : NOT formula",
"formula : NEXT formula",
"formula : GLOBALLY formula",
"formula : FUTURE formula",
"formula : formula AND formula",
"formula : formula OR formula",
"formula : formula IMPLIES formula",
"formula : formula UNTIL formula",
"formula : formula RELEASE formula",
"formula : LPAREN formula RPAREN",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 436 "yaccLTL.cc"

/*node * main(void) {
    return yyparse();
} /*end main*/

#line 263 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 98 "yaccLTL.cc"
{ /*a simple top-level to assign the root*/
    root = yyvsp[0].nPtr;
    /*fprintf(stderr, "Finished parsing formula\n");*/
}
break;
case 2:
#line 105 "yaccLTL.cc"
{ 
    /*printf("Found a leaf\n"); */
    numPROP++; /*count it*/
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc((strlen(yylval.varName)+1)*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error25\n"); exit(1); }
    strcpy(current->me, yylval.varName); /*copy in the operator*/
    /*fprintf(stderr, "1 saving %s\n", current->me);*/
    current->left_kid = NULL;
    current->right_kid = NULL;
    current->temp_kid = 0; /*no temporal children*/
    yyval.nPtr = current;
    formula_length += strlen(yylval.varName)+3;
    /*fprintf(stderr, "Found a proposition (%s) of length %d\n", yylval.varName, strlen(yylval.varName));*/

    /*Check if we've declared this variable yet*/
    search.setName(current->me);
    used = varList.query(search);
    if (used == 0) { /*we haven't used this variable name yet*/
	/*Add the var to the list so we don't use it again*/
	/*current->num = */
	varList.addItem(search);
	/*Make self-loops at all vertices in the variable graph*/
	/*connect_graph(current->num, current->num);*/
    } /*end if*/
    current->num = -1;
    /*printf("Parsed a simple subformula.\n"); */
}
break;
case 3:
#line 134 "yaccLTL.cc"
{ 
    /*printf("Found a TRUE\n"); */
    numTRUE++; /*count it*/
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc(6*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error25\n"); exit(1); }
    strcpy(current->me, "TRUE"); /*copy in the operator*/
    /*fprintf(stderr, "1 saving %s\n", current->me);*/
    current->left_kid = NULL;
    current->right_kid = NULL;
    current->temp_kid = 0; /*no temporal children*/
    yyval.nPtr = current;
    formula_length += 6;
    /*printf("Found a TRUE\n");*/
    /*printf("Parsed a simple subformula.\n"); */
}
break;
case 4:
#line 151 "yaccLTL.cc"
{ 
  /*fprintf(stderr, "Found a FALSE\n");*/
    numFALSE++; /*count it*/
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc(7*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error25\n"); exit(1); }
    strcpy(current->me, "FALSE"); /*copy in the operator*/
    /*fprintf(stderr, "1 saving %s\n", current->me);*/
    current->left_kid = NULL;
    current->right_kid = NULL;
    current->temp_kid = 0; /*no temporal children*/
    yyval.nPtr = current;
    formula_length += 7;
    /*printf("Parsed a simple subformula.\n"); */
}
break;
case 5:
#line 167 "yaccLTL.cc"
{
    /*printf("Found a '~' operator\n"); */
    /*numNonTemporalOps++; /*DON'T count it: NOT's are dispensible*/
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc(2*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error12\n"); exit(1); }
    current->me[0] = '~'; /*copy in the operator*/
    current->me[1] = '\0'; /*end the string*/
    /*fprintf(stderr, "Saving %s\n", current->me);*/
    current->num = -1;
    current->left_kid = NULL;
    current->right_kid = yyvsp[0].nPtr;
    current->right_kid->parent = current;
    if ((current->right_kid->me[0] == 'X')
	|| (current->right_kid->me[0] == 'U')
	|| (current->right_kid->me[0] == 'R')
	|| (current->right_kid->me[0] == 'F')
	|| (current->right_kid->me[0] == 'G')) {
	current->temp_kid = 1;
    } /*end if*/
    else {
	current->temp_kid = 0; /*no temporal children*/
    } /*end else*/
    yyval.nPtr = current;
    formula_length += 3;
    /*printf("Done with '~' operator\n");*/
}
break;
case 6:
#line 195 "yaccLTL.cc"
{ 
    /*printf("Found a 'X' operator\n"); */
    numX++; /*count it*/
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc(2*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error12\n"); exit(1); }
    current->me[0] = 'X'; /*copy in the operator*/
    current->me[1] = '\0'; /*end the string*/
    /*fprintf(stderr, "Saving %s\n", current->me);*/
    current->num = -1;
    current->left_kid = NULL;
    current->right_kid = yyvsp[0].nPtr;
    current->right_kid->parent = current;
    if ((current->right_kid->me[0] == 'X')
	|| (current->right_kid->me[0] == 'U')
	|| (current->right_kid->me[0] == 'R')
	|| (current->right_kid->me[0] == 'F')
	|| (current->right_kid->me[0] == 'G')) {
	current->temp_kid = 1;
    } /*end if*/
    else {
	current->temp_kid = 0; /*no temporal children*/
    } /*end else*/
    yyval.nPtr = current;
    formula_length += 3;
    /*printf("Done with 'X' operator\n");*/
}
break;
case 7:
#line 223 "yaccLTL.cc"
{
    /*printf("Found a 'G' operator\n"); */
    numG++; /*count it*/
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc(2*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error12\n"); exit(1); }
    current->me[0] = 'G'; /*copy in the operator*/
    current->me[1] = '\0'; /*end the string*/
    /*fprintf(stderr, "Saving %s\n", current->me);*/
    current->num = -1;
    current->left_kid = NULL;
    current->right_kid = yyvsp[0].nPtr;
    current->right_kid->parent = current;
    if ((current->right_kid->me[0] == 'X')
	|| (current->right_kid->me[0] == 'U')
	|| (current->right_kid->me[0] == 'R')
	|| (current->right_kid->me[0] == 'F')
	|| (current->right_kid->me[0] == 'G')) {
	current->temp_kid = 1;
    } /*end if*/
    else {
	current->temp_kid = 0; /*no temporal children*/
    } /*end else*/
    if (current->right_kid->me[0] == 'F') {
	numGF++; /*count this special operator*/
    } /*end if*/
    yyval.nPtr = current;
    formula_length += 3;
    /*printf("Done with 'G' operator\n");*/
}
break;
case 8:
#line 254 "yaccLTL.cc"
{
    /*printf("Found an 'F' operator\n"); */
    numF++; /*count it*/
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc(2*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error12\n"); exit(1); }
    current->me[0] = 'F'; /*copy in the operator*/
    current->me[1] = '\0'; /*end the string*/
    /*fprintf(stderr, "Saving %s\n", current->me);*/
    current->num = -1;
    current->left_kid = NULL;
    current->right_kid = yyvsp[0].nPtr;
    current->right_kid->parent = current;
    if ((current->right_kid->me[0] == 'X')
	|| (current->right_kid->me[0] == 'U')
	|| (current->right_kid->me[0] == 'R')
	|| (current->right_kid->me[0] == 'F')
	|| (current->right_kid->me[0] == 'G')) {
	current->temp_kid = 1;
    } /*end if*/
    else {
	current->temp_kid = 0; /*no temporal children*/
    } /*end else*/
    yyval.nPtr = current;
    formula_length += 3;
    /*printf("Done with 'F' operator\n");*/
}
break;
case 9:
#line 282 "yaccLTL.cc"
{
    /*printf("Found a '&' operator\n"); */
    numNonTemporalOps++; /*count it*/
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc(2*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error12\n"); exit(1); }
    current->me[0] = '&'; /*copy in the operator*/
    current->me[1] = '\0'; /*end the string*/
    /*fprintf(stderr, "Saving %s\n", current->me);*/
    current->num = -1;
    current->left_kid = yyvsp[-2].nPtr;
    current->right_kid = yyvsp[0].nPtr;
    current->left_kid->parent = current;
    current->right_kid->parent = current;
    if ((current->right_kid->me[0] == 'X')    || (current->left_kid->me[0] == 'X')
	|| (current->right_kid->me[0] == 'U') || (current->left_kid->me[0] == 'U')
	|| (current->right_kid->me[0] == 'R') || (current->left_kid->me[0] == 'R')
	|| (current->right_kid->me[0] == 'F') || (current->left_kid->me[0] == 'F')
	|| (current->right_kid->me[0] == 'G') || (current->left_kid->me[0] == 'G')) {
	current->temp_kid = 1;
    } /*end if*/
    else {
	current->temp_kid = 0; /*no temporal children*/
    } /*end else*/
    yyval.nPtr = current;
    formula_length += 3;
    /*printf("Done with '&' operator\n");*/
}
break;
case 10:
#line 311 "yaccLTL.cc"
{
    /*fprintf(stderr, "Found a '|' operator\n"); */
    numNonTemporalOps++; /*count it*/
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc(2*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error12\n"); exit(1); }
    current->me[0] = '|'; /*copy in the operator*/
    current->me[1] = '\0'; /*end the string*/
    /*fprintf(stderr, "Saving %s\n", current->me);*/
    current->num = -1;
    current->left_kid = yyvsp[-2].nPtr;
    current->right_kid = yyvsp[0].nPtr;
    current->left_kid->parent = current;
    current->right_kid->parent = current;
    if ((current->right_kid->me[0] == 'X')    || (current->left_kid->me[0] == 'X')
	|| (current->right_kid->me[0] == 'U') || (current->left_kid->me[0] == 'U')
	|| (current->right_kid->me[0] == 'R') || (current->left_kid->me[0] == 'R')
	|| (current->right_kid->me[0] == 'F') || (current->left_kid->me[0] == 'F')
	|| (current->right_kid->me[0] == 'G') || (current->left_kid->me[0] == 'G')) {
	current->temp_kid = 1;
    } /*end if*/
    else {
	current->temp_kid = 0; /*no temporal children*/
    } /*end else*/
    yyval.nPtr = current;
    formula_length += 3;
    /*printf("Done with '|' operator\n");*/
}
break;
case 11:
#line 340 "yaccLTL.cc"
{
    /*printf("Found a '->' operator\n"); */
    numNonTemporalOps++; /*count it: maybe count twice for now since it's ~|? */
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc(2*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error12\n"); exit(1); }
    current->me[0] = '-'; /*copy in the operator*/
    current->me[1] = '\0'; /*end the string*/
    /*fprintf(stderr, "Saving %s\n", current->me);*/
    current->num = -1;
    current->left_kid = yyvsp[-2].nPtr;
    current->right_kid = yyvsp[0].nPtr;
    current->left_kid->parent = current;
    current->right_kid->parent = current;
    if ((current->right_kid->me[0] == 'X')    || (current->left_kid->me[0] == 'X')
	|| (current->right_kid->me[0] == 'U') || (current->left_kid->me[0] == 'U')
	|| (current->right_kid->me[0] == 'R') || (current->left_kid->me[0] == 'R')
	|| (current->right_kid->me[0] == 'F') || (current->left_kid->me[0] == 'F')
	|| (current->right_kid->me[0] == 'G') || (current->left_kid->me[0] == 'G')) {
	current->temp_kid = 1;
    } /*end if*/
    else {
	current->temp_kid = 0; /*no temporal children*/
    } /*end else*/
    yyval.nPtr = current;
    formula_length += 4;
    /*printf("Done with '->' operator\n");*/
}
break;
case 12:
#line 369 "yaccLTL.cc"
{
    /*printf("Found a 'U' operator\n"); */
    numU++; /*count it*/
    /*fprintf(stderr, "Found a U!\n");*/
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc(2*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error12\n"); exit(1); }
    current->me[0] = 'U'; /*copy in the operator*/
    current->me[1] = '\0'; /*end the string*/
    /*fprintf(stderr, "Saving %s\n", current->me);*/
    current->num = -1;
    current->left_kid = yyvsp[-2].nPtr;
    current->right_kid = yyvsp[0].nPtr;
    current->left_kid->parent = current;
    current->right_kid->parent = current;
    if ((current->right_kid->me[0] == 'X')    || (current->left_kid->me[0] == 'X')
	|| (current->right_kid->me[0] == 'U') || (current->left_kid->me[0] == 'U')
	|| (current->right_kid->me[0] == 'R') || (current->left_kid->me[0] == 'R')
	|| (current->right_kid->me[0] == 'F') || (current->left_kid->me[0] == 'F')
	|| (current->right_kid->me[0] == 'G') || (current->left_kid->me[0] == 'G')) {
	current->temp_kid = 1;
    } /*end if*/
    else {
	current->temp_kid = 0; /*no temporal children*/
    } /*end else*/
    yyval.nPtr = current;
    formula_length += 3;
    /*printf("Done with 'U' operator\n");*/
}
break;
case 13:
#line 399 "yaccLTL.cc"
{
    /*printf("Found an 'R' operator\n"); */
    numR++; /*count it*/
    current = (struct node *)malloc(sizeof(struct node));
    if (current==NULL){ fprintf(stderr, "Memory error11\n"); exit(1); }
    current->me = (char *)malloc(2*sizeof(char));
    if (current->me==NULL){ fprintf(stderr, "Memory error12\n"); exit(1); }
    current->me[0] = 'R'; /*copy in the operator*/
    current->me[1] = '\0'; /*end the string*/
    /*fprintf(stderr, "Saving %s\n", current->me);*/
    current->num = -1;
    current->left_kid = yyvsp[-2].nPtr;
    current->right_kid = yyvsp[0].nPtr;
    current->left_kid->parent = current;
    current->right_kid->parent = current;
    if ((current->right_kid->me[0] == 'X')    || (current->left_kid->me[0] == 'X')
	|| (current->right_kid->me[0] == 'U') || (current->left_kid->me[0] == 'U')
	|| (current->right_kid->me[0] == 'R') || (current->left_kid->me[0] == 'R')
	|| (current->right_kid->me[0] == 'F') || (current->left_kid->me[0] == 'F')
	|| (current->right_kid->me[0] == 'G') || (current->left_kid->me[0] == 'G')) {
	current->temp_kid = 1;
    } /*end if*/
    else {
	current->temp_kid = 0; /*no temporal children*/
    } /*end else*/
    yyval.nPtr = current;
    formula_length += 3;
    /*printf("Done with 'R' operator\n");*/
}
break;
case 14:
#line 428 "yaccLTL.cc"
{ 
    /*printf("Found parens!\n"); */
    yyval.nPtr = yyvsp[-1].nPtr;
    formula_length += 2;
}
break;
#line 832 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
